var g_IsIE = false;
var g_IsNN = false;
var g_IsOpera = false;
var g_IsGecko = false;
var g_Version = 0.0;
while(true)
{
	if(0 <= navigator.userAgent.indexOf("Opera"))
	{
		g_IsOpera = true;
		navigator.userAgent.match(/Opera\s([\d\.]+)/i);
		g_Version = RegExp.$1;
		break;
	}
	if(navigator.appName == "Microsoft Internet Explorer")
	{
		g_IsIE = true;
		navigator.userAgent.match(/MSIE\s([\d\.]+)/i);
		g_Version = RegExp.$1;
		break;
	}
	if((navigator.appName == "Netscape")
	 ||(0 <= navigator.userAgent.indexOf("Netscape")))
	{
		g_IsNN = true;
		navigator.userAgent.match(/Mozilla\/([\d\.]+)/i);
	////navigator.userAgent.match(/Netscape\d\/([\d\.]+)/i);		// Netscape Navigator 6
		g_Version = RegExp.$1;
		break;
	}
	if(0 <= navigator.userAgent.indexOf("Gecko"))
	{
		g_IsGecko = true;
		navigator.userAgent.match(/Mozilla\/([\d\.]+)/i);
		g_Version = RegExp.$1;
		break;
	}
	break;
}

Array.prototype.toString = "Array";


function ListTag(iOffset,
				 iLength)
{
//	this.bSortReverse = bSortReverse;
	this.iOffset = iOffset;
	this.iLength = iLength;
}


function LengthClip(fromName,
				    sText,
				    iLength)
{
	this.fromName = fromName;
	this.sText = sText;
	this.iLength = iLength;
}


function FindStruct(sTitle,
					oFindFirst,
					oFindNext,
					oSelect)
{
	this.sTitle = sTitle;
	this.mRegExp = null;
	this.sLastMatch = null;
	this.iSelectedIndex = 0;
	this.mFindFirst = oFindFirst;
	this.mFindNext = oFindNext;
	this.mSelect = oSelect;
}
FindStruct.prototype.toString = "FindStruct";


function IsMultibyteChar(iCode)
{
	if(0x0080 > iCode)
	{
		return false;
	}
	if(0x00a0 == iCode)
	{
		return false;
	}
	if((0xff61 <= iCode)
	 &&(0xff9f >= iCode))
	{
		return false;
	}
	return true;
}


function GetLength(sSource)
{
	if(null == sSource)
	{
		return 0;
	}
	var iLength = 0;
	var iIndex = 0;
	if((g_IsNN)
	 &&(g_Version < 5.0))
	{
		while(iIndex < sSource.length)
		{
			if((sSource.charAt(iIndex) == "%")
			 &&(sSource.charAt(iIndex + 1) == "u"))
			{
				iIndex += 6;
				iLength += 2;
			}
			else
			{
				iIndex++;
				iLength++;
			}
		}
		return iLength;
	}
	while(iIndex < sSource.length)
	{
		iLength++;
		var iCode = sSource.charCodeAt(iIndex++);
		if(IsMultibyteChar(iCode))
		{
			iLength++;
		}
	}
	return iLength;
}


function Trim(sSource)
{
	if(null == sSource)
	{
		return null;
	}
	var iLength = sSource.length;
	var iIndex = iLength;
	while(0 < iIndex)
	{
		var iCode = sSource.charCodeAt(--iIndex);
		if((0x0020 < iCode)
		 &&(0x00a0 != iCode))
		{
			break;
		}
		iLength--;
	}
	var sDestination = "";
	for(var iIndex = 0; iIndex < iLength; iIndex++)
	{
		if(sSource.charCodeAt(iIndex) == 0x00a0)
		{
			sDestination += "\x20";
		}
		else
		{
			sDestination += sSource.charAt(iIndex);
		}
	}
	return sDestination;
}


function GetSubString(sSource,
					  iOffset,
					  iLength)
{
	var iMaxLength = GetLength(sSource);
	if((0 >= iLength)
	 ||(iMaxLength < iLength))
	{
		iLength = iMaxLength;
	}
	var iIndex = 0;
	var iStart = 0;
	if(iOffset)
	{
		while((iStart < iOffset)
			&&(iStart < iLength))
		{
			iStart++;
			var iCode = sSource.charCodeAt(iIndex++);
			if(IsMultibyteChar(iCode))
			{
				iStart++;
			}
		}
	}
	var sDestination = "";
	while(iStart < iLength)
	{
		sDestination += sSource.charAt(iIndex);
		iStart++;
		var iCode = sSource.charCodeAt(iIndex++);
		if(IsMultibyteChar(iCode))
		{
			iStart++;
		}
	}
	return sDestination;
}


function CompareString(string1,
					   string2)
{
	var iLength1 = GetLength(string1);
	var iLength2 = GetLength(string2);
	var iIndex = 0;
	while((iIndex < iLength1)
		&&(iIndex < iLength2))
	{
		var iDifference = 0;
		var iCharacter1 = string1.charCodeAt(iIndex);
		var iCharacter2 = string2.charCodeAt(iIndex);
		if(0x7f > iCharacter1)
		{
			if(0x7f > iCharacter2)
			{
				if((0x61 <= iCharacter1)
				 &&(0x7a >= iCharacter1))
				{
					iCharacter1 -= 0x20;
				}
				if((0x61 <= iCharacter2)
				 &&(0x7a >= iCharacter2))
				{
					iCharacter2 -= 0x20;
				}
				iDifference = iCharacter2 - iCharacter1;
			}
			else
			{
				iDifference = 1;
			}
		}
		else
		{
			if(0x7f > iCharacter2)
			{
				iDifference = -1;
			}
			else
			{
				iDifference = iCharacter2 - iCharacter1;
			}
		}
		if(iDifference)
		{
			return iDifference;
		}
		iIndex++;
	}
	return iLength2 - iLength1;
}


function CustomOption(key,
					  value,
					  text,
					  selected)
{
	this.key = key;
	this.value = value;
	this.text = text;
	this.selected = selected;
}


function CompareOptions(option1,
						option2)
{
	return CompareString(option1.key, option2.key);
}


function SortOptions(formOptions,
					 iOffset,
					 iLength)
{
	var aSort = new Array();
	var iOption = 0;
	while(iOption < formOptions.length)
	{
		var sKey;
		if(false)
		{
			if(0 < iLength)
			{
				sKey = formOptions[iOption].text.substring(iOffset, iOffset + iLength);
			}
			else
			{
				sKey = formOptions[iOption].text.substring(iOffset);
			}
		}
		else
		{
			sKey = GetSubString(formOptions[iOption].text, iOffset, iLength);
		}
		sKey = Trim(sKey);
		aSort[iOption] = new CustomOption(sKey,
										  formOptions[iOption].value,
										  formOptions[iOption].text,
										  formOptions[iOption].selected);
		iOption++;
	}
	aSort.sort(CompareOptions);
	iOption = 0;
	while(iOption < aSort.length)
	{
		if(formOptions[iOption].text != aSort[iOption].text)
		{
			while(iOption < aSort.length)
			{
				formOptions[iOption].value = aSort[iOption].value;
				formOptions[iOption].text = aSort[iOption].text;
				formOptions[iOption].selected = aSort[iOption].selected;
				iOption++;
			}
			return true;
		}
		formOptions[iOption].value = aSort[iOption].value;
		formOptions[iOption].selected = aSort[iOption].selected;
		iOption++;
	}
	var iSort = 0;
	iOption = aSort.length - 1;
	while(0 <= iOption)
	{
		formOptions[iOption].value = aSort[iSort].value;
		formOptions[iOption].text = aSort[iSort].text;
		formOptions[iOption].selected = aSort[iSort].selected;
		iSort++;
		iOption--;
	}
	return true;
}


function MoveOptions(formDestination,
					 formSource)
{
	var iSource = 0;
	var iDestination = formDestination.length;
	while(iSource < formSource.length)
	{
		if(formSource[iSource].selected)
		{
			formDestination[iDestination] = new Option();
			formDestination[iDestination].value = formSource[iSource].value;
			formDestination[iDestination].text = formSource[iSource].text;
			formDestination[iDestination].selected = false;
			iDestination++;
			formSource[iSource] = null;
		}
		else
		{
			iSource++;
		}
	}
}


function MoveOptions2(form,
					  sKeepEntry)
{
	var formDestination = form.formDenyUsers.options;
	var formSource = form.formAllowUsers.options;
	var iSource = 0;
	var iDestination = formDestination.length;
	var bIsAdmin = false;
	while(iSource < formSource.length)
	{
		if(!formSource[iSource].selected)
		{
			iSource++;
			continue;
		}
		if((!bIsAdmin)
		 &&(!g_bIsDebug)
		 &&(formSource[iSource].value == sKeepEntry))
		{
			bIsAdmin = true;
			iSource++;
			continue;
		}
		formDestination[iDestination] = new Option();
		formDestination[iDestination].value = formSource[iSource].value;
		formDestination[iDestination].text = formSource[iSource].text;
		formDestination[iDestination].selected = false;
		iDestination++;
		formSource[iSource] = null;
	}
	if(bIsAdmin)
	{
		alert("롼פϼȤҤǤޤ");
	}
}


function RepaintButton()
{
	if(g_IsNN || g_IsOpera || g_IsGecko)
	{
		document.fgColor = document.fgColor;
	}
}


function EnableButton(formButton,
					  bEnable)
{
	if(formButton.toString == "Array")
	{
		for(var iButton = 0; iButton < formButton.length; iButton++)
		{
/*
			if((bEnable)
			 &&(formButton[iButton].name == "formOpenPath"))
			{
				var formOptions = formButton[iButton].form.formUsers.options;
				var iOption = 0;
				while(iOption < formOptions.length)
				{
					if(formOptions[iOption].selected)
					{
						var frame = window;
						if(null != parent)
						{
							frame = parent;
						}
						formButton[iButton].disabled = (null == frame.g_aPath[formOptions[iOption].value]);
						break;
					}
					iOption++;
				}
			}
			else
*/
				if(formButton[iButton].toString == "FindStruct")
				{
					formButton[iButton].mFindFirst.disabled = !bEnable;
					formButton[iButton].mFindNext.disabled = ((!bEnable) || (null == formButton[iButton].mRegExp));
				}
				else
				{
					formButton[iButton].disabled = !bEnable;
				}
		}
	}
	else
	{
		if(formButton.name == "formOpenPath")
		{
			formButton.disabled = !bEnable;
		}
		else
		{
			formButton.disabled = !bEnable;
		}
	}
	RepaintButton();
}


var g_aFormElements = new Array();
var g_aChangePassword = new Array();

function LoadFrom(form)
{
//	g_aFormElements = new Array();
	var aElements = form.elements;
	for(var iElement = 0; iElement < aElements.length; iElement++)
	{
		var sName = aElements[iElement].name;
		if(aElements[iElement].type == "text")
		{
			g_aFormElements[sName] = aElements[iElement].value;
			continue;
		}
		if((!g_IsOpera)
		 &&(aElements[iElement].type == "password"))
		{
			g_aFormElements[sName] = aElements[iElement].value;
			g_aChangePassword[sName] = false;
			continue;
		}
		if((aElements[iElement].type == "checkbox")
		 ||(aElements[iElement].type == "radio"))
		{
			g_aFormElements[sName] = aElements[iElement].checked;
			continue;
		}
		if((aElements[iElement].type == "select")
		 ||(aElements[iElement].type == "select-multiple"))
		{
			var aOptions = aElements[iElement].options;
			g_aFormElements[sName] = "";
			for(var iOption = 0; iOption < aOptions.length; iOption++)
			{
				g_aFormElements[sName] += aOptions[iOption].value;
				g_aFormElements[sName] += "\n";
			}
			continue;
		}
	}
}


function IsChanged(formItem)
{
	if(formItem.type == "text")
	{
		return g_aFormElements[formItem.name] != formItem.value;
	}
	if((!g_IsOpera)
	 &&(formItem.type == "password"))
	{
		var sName = formItem.name;
		g_aChangePassword[sName] = (g_aFormElements[sName] != formItem.value);
		return g_aChangePassword[sName];
	}
	if((formItem.type == "checkbox")
	 ||(formItem.type == "radio"))
	{
		return g_aFormElements[formItem.name] != formItem.checked;
	}
	if((formItem.type == "select")
	 ||(formItem.type == "select-multiple"))
	{
		var aPrevios = new Array();
		var iRow = 0;
		var iOffset = 0;
		while(iOffset < g_aFormElements[formItem.name].length)
		{
			var iWidth = g_aFormElements[formItem.name].indexOf("\n" , iOffset);
			if(0 > iWidth)
			{
				break;
			}
			iRow++;
			var sValue = g_aFormElements[formItem.name].substring(iOffset, iWidth);
			aPrevios[sValue] = "";
			aPrevios[sValue] = sValue;
			iOffset = iWidth + 1;
		}
		if(iRow != formItem.length)
		{
			return true;
		}
		for(var iOption = 0; iOption < formItem.options.length; iOption++)
		{
			if(!aPrevios[formItem.options[iOption].value])
			{
				return true;
			}
		}
	}
	return false;
}


function EnableButtonOnKeyUp(formButton,
							 formItem)
{
	if(formButton.disabled)
	{
		if((g_bIsDebug)
		 ||(IsChanged(formItem)))
		{
			EnableButton(formButton, true);
			return true;
		}
	}
	else
	{
		if(g_bIsDebug)
		{
			return false;
		}
		if(!IsChanged(formItem))
		{
			var aElements = formItem.form.elements;
			var iElement = 0;
			while(iElement < aElements.length)
			{
				var sName = aElements[iElement].name;
				if(IsChanged(aElements[iElement]))
				{
					return false;
				}
				iElement++;
			}
			EnableButton(formButton, false);
			return true;
		}
	}
	return false;
}


function EnableButtonOnSelect(formButton,
							  formSelect)
{
/*
	if(2 >= arguments.length)
	{
		var formButton = arguments[0];
		var formSelect = arguments[1];
	}
	else
	{
		var formButton = new Array();
		for(var iArgument = 0; iArgument < arguments.length - 1; iArgument++)
		{
			formButton = formButton.concat(arguments[iArgument]);
		}
		var formSelect = arguments[iArgument];
    }
*/
	formSelect.disabled = false;
	if(0 <= formSelect.selectedIndex)
	{
		EnableButton(formButton, true);
		return false;
	}
	var formOptions = formSelect.options;
	var iOption = 0;
	while(iOption < formOptions.length)
	{
		if(formOptions[iOption].selected)
		{
			EnableButton(formButton, true);
			return false;
		}
		iOption++;
	}
	for(var iButton = 0; iButton < formButton.length; iButton++)
	{
		if(formButton[iButton].toString == "FindStruct")
		{
			formButton[iButton].mFindFirst.disabled = false;
			formButton[iButton].mFindNext.disabled = (null == formButton[iButton].mRegExp);
		}
		else
		{
			formButton[iButton].disabled = true;
		}
	}
	RepaintButton();
	return false;
}


function AppendUser(formButton)
{
	var form = formButton.form;
	MoveOptions(form.formAllowUsers.options,
				form.formDenyUsers.options);
	form.formAppendUsers.disabled = true;
	EnableButtonOnSelect(formButton, form.formDenyUsers);
	EnableButtonOnKeyUp(form.formSetProperty, form.formAllowUsers);
}


function AppendPath(formDestination,
					formSource)
{
	var iDestination = formDestination.length;
	var iOption = 0;
	if(g_bIsDebug)
	{
		iOption = iDestination;
	}
	while(iOption < iDestination)
	{
		var sDestination = formDestination[iOption].value;
		var iLength = sDestination.length - 1;
		if(sDestination.charAt(iLength) == '/')
		{
			sDestination = sDestination.substring(0, iLength);
		}
		var sSource = formSource.value;
		iLength = sSource.length - 1;
		if(sSource.charAt(iLength) == '/')
		{
			sSource = sSource.substring(0, iLength);
		}
		if(sDestination == sSource)
		{
			break;
		}
		iOption++;
	}
	if(iOption >= iDestination)
	{
		formDestination[iDestination] = new Option();
		formDestination[iDestination].value = formSource.value;
		formDestination[iDestination].text = formSource.value;
		formDestination[iDestination].selected = false;
	}
//	formSource.value = "http://";
	formSource.form.formAppendUsers.disabled = true;
	EnableButtonOnKeyUp(formSource.form.formSetProperty, formDestination);
}


function RemoveUser(formButton)
{
	var form = formButton.form;
	MoveOptions(form.formDenyUsers.options,
				form.formAllowUsers.options);
	form.formRemoveUsers.disabled = true;
	EnableButtonOnSelect(formButton, form.formAllowUsers);
	EnableButtonOnKeyUp(form.formSetProperty, form.formDenyUsers);
}


function RemoveUser2(formButton,
					 sKeep)
{
	var form = formButton.form;
	MoveOptions2(form, sKeep);
	form.formRemoveUsers.disabled = true;
	EnableButtonOnSelect(formButton, form.formAllowUsers);
	EnableButtonOnKeyUp(form.formSetProperty, form.formDenyUsers);
}


function RemovePath(formDestination,
					formSource)
{
	var iSource = 0;
	while(iSource < formSource.length)
	{
		if(formSource[iSource].selected)
		{
			formSource[iSource] = null;
		}
		else
		{
			iSource++;
		}
	}
	formDestination.form.formRemoveUsers.disabled = true;
	EnableButtonOnKeyUp(formSource.form.formSetProperty, formSource);
}


function SortList(formButton,
				  formSelect,
				  sTag)
{
	if(1 >= formSelect.options.length)
	{
		return true;
	}
	formButton.disabled = true;
	var aTag = new Array();
	aTag["name"] = new ListTag(0, 8);
	aTag["description"] = new ListTag(8 + 1, 0);
	aTag["longdescription"] = new ListTag(8 + 1, 0);
	aTag["appname"] = new ListTag(40 + 1, 0);
	aTag["appdescription"] = new ListTag(0, 40);
	aTag["pathurl"] = new ListTag(0, 0);
	var sSelected = "";
	if(g_IsOpera)
	{
		if(0 <= formSelect.selectedIndex)
		{
			sSelected = formSelect.options[formSelect.selectedIndex].value;
		}
/*
		for(var iOption = 0; iOption < formSelect.options.length; iOption++)
		{
			var sValue = formSelect.options[iOption].value;
			aSelected[sValue] = formSelect.options[iOption].selected;
		}
*/
	}
	SortOptions(formSelect.options,
				aTag[sTag].iOffset,
				aTag[sTag].iLength);
	if(g_IsOpera)
	{
		if("" != sSelected)
		{
			for(var iOption = 0; iOption < formSelect.options.length; iOption++)
			{
				var sValue = formSelect.options[iOption].value;
				if(sSelected == sValue)
				{
					formSelect.selectedIndex = iOption;
					break;
				}
			}
		}
		else
		{
			formSelect.selectedIndex = -1;
		}
	}
	formButton.disabled = false;
	return true;
}


function ClearSelected(formSelect,
					   formButtons,
					   sDelete)
{
	var aOptions = formSelect.options;
	if(null != sDelete)
	{
		for(var iOption = 0; iOption < aOptions.length; iOption++)
		{
			if(aOptions[iOption].text == sDelete)
			{
				formSelect.options[iOption] = null;
			}
		}
	}
	EnableButtonOnSelect(formButtons, formSelect);
}


function OpenPropertyNew(formButtons,
						 formSelect,
						 sAction)
{
	formSelect.selectedIndex = -1;
	var aOptions = formSelect.options;
	for(var iOption = 0; iOption < aOptions.length; iOption++)
	{
		aOptions[iOption].selected = false;
	}
	formSelect.disabled = true;
	EnableButton(formButtons, false);
	formSelect.form.action = sAction;
	formSelect.form.submit();
//	formSelect.form.reset();
}


function OpenPropertySingle(formButtons,
							formSelect,
							sAction,
							nWidth)
{
	if(0 <= formSelect.selectedIndex)
	{
		formSelect.disabled = true;
		EnableButton(formButtons, false);
//		var sParam = formSelect.options[formSelect.selectedIndex].text;
//		sParam = Trim(GetSubString(sParam, 0, nWidth));
		var sParam = formSelect.options[formSelect.selectedIndex].value;
		formSelect.form.action = sAction;
		formSelect.form.formSelected.value = sParam;
		formSelect.form.submit();
	}
}


function OpenPropertySingle2(formButtons,
							 formSelect,
							 sAction,
							 nWidth)
{
	if(0 <= formSelect.selectedIndex)
	{
		formSelect.disabled = true;
		EnableButton(formButtons, false);
		var oOption = formSelect.options[formSelect.selectedIndex];
		var sParam = oOption.text;
		sParam = Trim(GetSubString(sParam, nWidth, 0));
		formSelect.form.formSelected.value = sParam;
		formSelect.form.formAppID.value = oOption.value;
		formSelect.form.action = sAction;
		formSelect.form.submit();
	}
}


function OpenProperty(formSelect,
					  sTarget,
					  sAction)
{
	if(0 <= formSelect.selectedIndex)
	{
		var formOption = formSelect.options[formSelect.selectedIndex];
		document.layers[sTarget].load(sAction + "?" + formOption.text);
	}
}


function IsTooLong(formTarget,
				   oLengthClipSet)
{
	var oTooLong = null;
	if(oLengthClipSet.toString == "Array")
	{
		var iLengthClip = 0;
		while(iLengthClip < oLengthClipSet.length)
		{
			var sfromName = oLengthClipSet[iLengthClip].fromName;
			var formItem = formTarget.elements[sfromName];
			if(GetLength(formItem.value) > oLengthClipSet[iLengthClip].iLength)
			{
				oTooLong = oLengthClipSet[iLengthClip];
				break;
			}
			iLengthClip++;
		}
	}
	else
	{
		var sfromName = oLengthClipSet.fromName;
		var formItem = formTarget.elements[sfromName];
		if(GetLength(formItem.value) > oLengthClipSet.iLength)
		{
			oTooLong = oLengthClipSet;
		}
	}
	if(null != oTooLong)
	{
		alert(oTooLong.sText + "Ĺޤ\n"
			+ "Ⱦѱѿǿ " + oTooLong.iLength + " ʸϤƤ");
		return true;
	}
	return false;
}


function IsEmpty(sValue)
{
	if((null == sValue)
	 ||("" == sValue))
	{
		return true;
	}
	var iLength = sValue.length;
	var iIndex = 0;
	while(iIndex < iLength)
	{
		var iCode = sValue.charCodeAt(iIndex++);
		if((iCode > 0x20)
		 &&(iCode != 0xa0))
		{
			return false;
		}
	}
	return true;
}


function ConfirmPassword(formTarget)
{
	if(!g_bIsDebug)
	{
		var sPassword = formTarget.formPassword.value;
		if("" == sPassword)
		{
			alert("ѥɤǤ");
			return false;
		}
		if(sPassword != formTarget.formPasswordConfirm.value)
		{
			alert("ǧΥѥɤְäƤޤ\n"
				+ "ѥɤȳǧϤפ褦ˤƤ");
			return false;
		}
		var sNotice = "";
		var iMinLength = 3;
		if(sPassword.length < iMinLength)
		{
			sNotice += iMinLength + " ʸʲΥѥɤûޤ\n";
		}
		var formName = formTarget.elements["formSelected"];
		if(null != formName)
		{
		/*
			var iNameLength = formName.value.length;
			if(iNameLength > 4)
			{
				iNameLength = 4;
			}
			var sWord = formName.value.substring(0, iNameLength);
			var oRegularExpression = new RegExp("^\[a-z|0-9|_|~]*" + sWord + "[a-z|0-9|_|~]*$", "i");
			if(sPassword.match(oRegularExpression))
			{
				sNotice += "ѥɤñޤ\n";
			}
		*/
			if(sPassword == formName.value)
			{
				sNotice += "ѥɤ桼̾ƱǤ\n";
			}
		}
		var formDescription = formTarget.elements["formDescription"];
		if(null != formDescription)
		{
			if(formDescription.value.match(new RegExp(sPassword, "i")))
			{
				sNotice += "˥ѥɤ񤫤Ƥޤ\n";
			}
		}
		if("" != sNotice)
		{
			sNotice += "ΤޤϿޤ";
			return confirm(sNotice);
		}
	}
	return true;
}


function ConfirmUserName(formUserName,
						 formSelect)
{
	var aOptions = formSelect.options;
	for(var iOption = 0; iOption < aOptions.length; iOption++)
	{
		if(formUserName.value == Trim(GetSubString(aOptions[iOption].text, 0, 8)))
		{
			return false;
		}
	}
	return true;
}


function IsIncludedMultibyteChar(sSource)
{
	var iIndex = 0;
	while(iIndex < sSource.length)
	{
		var iCode = sSource.charCodeAt(iIndex++);
		if(IsMultibyteChar(iCode))
		{
			return true;
		}
	}
	return false;
}


function ConfirmURI(formItem)
{
	if(!g_bIsDebug)
	{
		var sURI = formItem.form.formURI.value;
		if(IsEmpty(sURI))
		{
			alert("URL Ǥ");
			return false;
		}
		if(IsEmpty(formItem.form.formName.value))
		{
			alert("ץꥱ̾Ǥ");
			return false;
		}
		if(0 <= sURI.search(/^https:\/\/.+/))
		{
			alert("ݸ줿꥽ϻѤǤޤ");
			return false;
		}
		if(0 > sURI.search(/^http:\/\/.+/))
		{
			alert("URL Ǥ");
			return false;
		}
		if(IsIncludedMultibyteChar(sURI))
		{
			alert("URL ˥ޥХʸޤ뤳ȤϤǤޤ");
			return false;
		}
	}
	return true;
}


function SubmitUserCreate(formButton)
{
	if(!g_bIsDebug)
	{
		if(IsEmpty(formButton.form.formSelected.value))
		{
			alert("桼̾Ǥ");
			return false;
		}
		if(!ConfirmUserName(formButton.form.formSelected,
							parent.document.formAccount.formUsers))
		{
			alert("桼̾ϴˤޤ");
			return false;
		}
		if(IsIncludedMultibyteChar(formButton.form.formSelected.value))
		{
			alert("桼̾˥ޥХʸޤ뤳ȤϤǤޤ");
			return false;
		}
		var oLengthClip = new Array(
			new LengthClip("formSelected", "桼̾", 8),
			new LengthClip("formDescription", "", 40),
			new LengthClip("formPassword", "ѥ", 16)
		);
		if(IsTooLong(formButton.form, oLengthClip))
		{
			return false;
		}
		if(!ConfirmPassword(formButton.form))
		{
			return false;
		}
	}
	formButton.form.formSubmit.value = "true";
	formButton.form.submit();
//	formButton.form.reset();
	return true;
}


function SubmitUserProperty(formButton)
{
	if(!g_bIsDebug)
	{
		if(IsTooLong(formButton.form, new LengthClip("formDescription", "", 40)))
		{
			return false;
		}
		if(!g_aChangePassword[formButton.form.formPassword.name])
		{
			formButton.form.formPassword.value = "";
		}
		else
		{
			if(IsTooLong(formButton.form, new LengthClip("formPassword", "ѥ", 16)))
			{
				return false;
			}
			if(!ConfirmPassword(formButton.form))
			{
				return false;
			}
		}
	}
	formButton.form.formSubmit.value = "true";
	formButton.form.submit();
//	formButton.form.reset();
	return true;
}


function SubmitUserPassword(formButton)
{
	if(!g_bIsDebug)
	{
		if(!g_aChangePassword[formButton.form.formPassword.name])
		{
			formButton.form.formPassword.value = "";
		}
		else
		{
			if(IsTooLong(formButton.form, new LengthClip("formPassword", "ѥ", 16)))
			{
				return false;
			}
			if(!ConfirmPassword(formButton.form))
			{
				return false;
			}
		}
	}
	formButton.form.submit();
//	formButton.form.reset();
	return true;
}


function SubmitGroupCreate(formButton)
{
	if(!g_bIsDebug)
	{
		if(IsEmpty(formButton.form.formName.value))
		{
			alert("롼̾Ǥ");
			return false;
		}
		if(!ConfirmUserName(formButton.form.formName,
							parent.document.formAccount.formUsers))
		{
			alert("롼̾ϴˤޤ");
			return false;
		}
		if(IsIncludedMultibyteChar(formButton.form.formName.value))
		{
			alert("롼̾˥ޥХʸޤ뤳ȤϤǤޤ");
			return false;
		}
		var oLengthClip = new Array(
			new LengthClip("formName", "롼̾", 8),
			new LengthClip("formDescription", "", 40)
		);
		if(IsTooLong(formButton.form, oLengthClip))
		{
			return false;
		}
	}
	formButton.form.formSubmit.value = "true";
	formButton.form.submit();
//	formButton.form.reset();
	return true;
}


function SubmitGroupProperty(formButton)
{
	if(!g_bIsDebug)
	{
		if(IsTooLong(formButton.form, new LengthClip("formDescription", "", 40)))
		{
			return false;
		}
	}
	formButton.form.formSubmit.value = "true";
	formButton.form.submit();
//	formButton.form.reset();
}


function SubmitAppCreate(formButton)
{
	if(!g_bIsDebug)
	{
/*
		var aOptions = parent.document.formAccount.formUsers.options;
		for(var iOption = 0; iOption < aOptions.length; iOption++)
		{
			if(formButton.form.formName.value == Trim(GetSubString(aOptions[iOption].text, 0, 32)))
			{
				alert("ץꥱ̾ϴˤޤ");
				return false;
			}
		}
*/
		if(!ConfirmURI(formButton))
		{
			return false;
		}
		var oLengthClip = new Array(
			new LengthClip("formName", "ץꥱ̾", 32),
			new LengthClip("formDescription", "", 40),
			new LengthClip("formURI", "URL ", 512)
		);
		if(IsTooLong(formButton.form, oLengthClip))
		{
			return false;
		}
	}
	formButton.form.formSubmit.value = "true";
	formButton.form.submit();
//	formButton.form.reset();
	return true;
}


function SubmitAppProperty(formButton)
{
	if(!g_bIsDebug)
	{
		if(!ConfirmURI(formButton))
		{
			return false;
		}
		var oLengthClip = new Array(
			new LengthClip("formName", "ץꥱ̾", 32),
			new LengthClip("formDescription", "", 40),
			new LengthClip("formURI", "URL ", 256)
		);
		if(IsTooLong(formButton.form, oLengthClip))
		{
			return false;
		}
	}
	formButton.form.formSubmit.value = "true";
	formButton.form.submit();
//	formButton.form.reset();
}


function GetSelected(formButtons,
					 formSelect)
{
	if(0 > formSelect.selectedIndex)
	{
		return "";
	}
	formSelect.disabled = true;
	EnableButton(formButtons, false);
	return formSelect.options[formSelect.selectedIndex].text;
}


function ConfirmRemoveUser(formButton)
{
	var sUser = GetSelected(g_ButtonUsers, g_SelectUsers);
	if("" == sUser)
	{
		return;
	}
	sUser = Trim(GetSubString(sUser, 0, 8));
	if(confirm("桼\n" + sUser + "\nޤ"))
	{
	//	formButton.form.formSelected.value = escape(sUser);
		formButton.form.formSelected.value = sUser;
		formButton.form.formRemove.value = true;
		formButton.form.target = "_self";
		formButton.form.action = "./removeuser.jsp";
		formButton.form.submit();
	}
	else
	{
		formButton.form.action = "blank.jsp";
		formButton.form.submit();
		EnableButtonOnSelect(g_ButtonUsers, g_SelectUsers);
	}
}


function ConfirmRemoveGroup(formButton)
{
	var sGroup = GetSelected(g_ButtonGroups, g_SelectGroups);
	if("" == sGroup)
	{
		return;
	}
	sGroup = Trim(GetSubString(sGroup, 0, 8));
	if(!g_bIsDebug)
	{
		if("admin" == sGroup)
		{
			alert("롼פϺǤޤ");
			return EnableButtonOnSelect(g_ButtonGroups, g_SelectGroups);
		}
	}
	if(confirm("롼\n" + sGroup + "\nޤ"))
	{
		formButton.form.formSelected.value = sGroup;
		formButton.form.formRemove.value = true;
		formButton.form.target = "_self";
		formButton.form.action = "./removegroup.jsp";
		formButton.form.submit();
	}
	else
	{
		formButton.form.action = "blank.jsp";
		formButton.form.submit();
		EnableButtonOnSelect(g_ButtonGroups, g_SelectGroups);
	}
}


function ConfirmRemoveApp(formButton)
{
	var sApp = GetSelected(g_ButtonApps, g_SelectApps);
	if("" == sApp)
	{
		return;
	}
//	sApp = Trim(GetSubString(sApp, 0, 32));
	sApp = Trim(GetSubString(sApp, 41, 0));
	if(confirm("ץꥱ\n" + sApp + "\nޤ"))
	{
		formButton.form.formSelected.value = sApp;
	//	formButton.form.formAppID.value = escape(g_SelectApps.options[g_SelectApps.selectedIndex].value);
		formButton.form.formAppID.value = g_SelectApps.options[g_SelectApps.selectedIndex].value;
		formButton.form.formRemove.value = "true";
		formButton.form.target = "_self";
		formButton.form.action = "./removeapp.jsp";
		formButton.form.submit();
	}
	else
	{
		formButton.form.action = "blank.jsp";
		formButton.form.submit();
		EnableButtonOnSelect(g_ButtonApps, g_SelectApps);
	}
}


function SetSelectedValues(formButton)
{
	var formOptions = formButton.form.formAllowUsers.options;
	var formAttaches = formButton.form.formAttaches;
	formAttaches.value = "\x0c";
	var iLength = formOptions.length;
	var iOption = 0;
	while(iOption < iLength)
	{
		formAttaches.value += formOptions[iOption].value;
		formAttaches.value += "\x0c";
		iOption++;
	}
}


function OnSorted(oFindStruct)
{
	oFindStruct.sLastMatch = null;
	if((0 > oFindStruct.mSelect.selectedIndex)
	 ||((oFindStruct.mSelect.selectedIndex + 1) >= oFindStruct.mSelect.options.length))
	{
		oFindStruct.iSelectedIndex = 0;
	}
	else
	{
		oFindStruct.iSelectedIndex = oFindStruct.mSelect.selectedIndex + 1;
	}
}


function Find(oFindStruct,
			  bFirst)
{
	if((bFirst)
	 ||(null == oFindStruct.mRegExp))
	{
		var sSearch=prompt(oFindStruct.sTitle + "ɽǸ", "");
		if(null != sSearch)
		{
			sSearch = Trim(sSearch);
			sSearch = sSearch.replace(/\(/, "").replace(/\)/, "");
			var sInputs = sSearch.replace(/\\\\/, "A").replace(/\\\./, "A");
				sInputs = sInputs.replace(/\\\?/, "A").replace(/\\\*/, "A");
				sInputs = sInputs.replace(/\\\{/, "A").replace(/\\\}/, "A");
				sInputs = sInputs.replace(/\\\[/, "A").replace(/\\\]/, "A");
			if((0 <= sInputs.indexOf("+."))
			 ||(0 <= sInputs.indexOf("?."))
			 ||(0 <= sInputs.indexOf("*."))
			 ||(0 <= sInputs.indexOf("++"))
			 ||(0 <= sInputs.indexOf("?+"))
			 ||(0 <= sInputs.indexOf("*+"))
			 ||(0 <= sInputs.indexOf("[+"))
			 ||(0 <= sInputs.indexOf("]+"))
			 ||(0 <= sInputs.indexOf(".?"))
			 ||(0 <= sInputs.indexOf("+?"))
			 ||(0 <= sInputs.indexOf("??"))
			 ||(0 <= sInputs.indexOf("*?"))
			 ||(0 <= sInputs.indexOf("[?"))
			 ||(0 <= sInputs.indexOf("]?"))
			 ||(0 <= sInputs.indexOf("+*"))
			 ||(0 <= sInputs.indexOf("?*"))
			 ||(0 <= sInputs.indexOf("**"))
			 ||(0 <= sInputs.indexOf("[*"))
			 ||(0 <= sInputs.indexOf("]*")))
			{
				alert("ɽ˸꤬ޤ");
				return false;
			}
			var sWork = new String(sInputs);
			while(0 <= sWork.indexOf("+"))
			{
				if(0 > sWork.search(/.\+/))
				{
					alert("ɽ˸꤬ޤ");
					return false;
				}
				if(g_IsIE)
				{
					sWork = sWork.substring(RegExp.lastIndex);
				}
				else
				{
					sWork = new String(RegExp.rightContext);
				}
			}
			sWork = new String(sInputs);
			while(0 <= sWork.indexOf("*"))
			{
				if(!sWork.match(/.\*/))
				{
					alert("ɽ˸꤬ޤ");
					return false;
				}
				if(g_IsIE)
				{
					sWork = sWork.substring(RegExp.lastIndex);
				}
				else
				{
					sWork = new String(RegExp.rightContext);
				}
			}
			sWork = new String(sInputs);
			while(0 <= sWork.indexOf("?"))
			{
				if(!sWork.match(/.\?/))
				{
					alert("ɽ˸꤬ޤ");
					return false;
				}
				if(g_IsIE)
				{
					sWork = sWork.substring(RegExp.lastIndex);
				}
				else
				{
					sWork = new String(RegExp.rightContext);
				}
			}
			sWork = new String(sInputs);
			while(0 <= sWork.indexOf("["))
			{
				if(!sWork.match(/\[.\]/))
				{
					alert("ɽ˸꤬ޤ");
					return false;
				}
				if(g_IsIE)
				{
					sWork = sWork.substring(RegExp.lastIndex);
				}
				else
				{
					sWork = new String(RegExp.rightContext);
				}
			}
			sWork = new String(sInputs);
			if(0 <= sWork.indexOf("$"))
			{
				if(!sWork.match(/.\$$/))
				{
					alert("ɽ˸꤬ޤ");
					return false;
				}
			}
			sWork = new String(sInputs);
			while(0 <= sWork.indexOf("{"))
			{
				if(!sWork.match(/.\{\d+,?d*\}/))
				{
					alert("ɽ˸꤬ޤ");
					return false;
				}
				if(g_IsIE)
				{
					sWork = sWork.substring(RegExp.lastIndex);
				}
				else
				{
					sWork = new String(RegExp.rightContext);
				}
			}
			var oRegExp = new RegExp(sSearch, "i");
			if(null == oRegExp)
			{
				alert("ɽ˸꤬ޤ");
				return false;
			}
			oFindStruct.mRegExp = oRegExp;
			oFindStruct.sLastMatch = null;
			oFindStruct.iSelectedIndex = 0;
		}
	}
	if(null != oFindStruct.mRegExp)
	{
		if(null != oFindStruct.mFindNext)
		{
			oFindStruct.mFindNext.disabled = true;
		}
		var aOptions = oFindStruct.mSelect.options;
		if(null != oFindStruct.sLastMatch)
		{
			if(oFindStruct.sLastMatch.match(oFindStruct.mRegExp))
			{
				if(g_IsIE)
				{
					oFindStruct.sLastMatch = oFindStruct.sLastMatch.substring(RegExp.index + 1);
				}
				else
				{
					oFindStruct.sLastMatch = oFindStruct.sLastMatch.substring(oFindStruct.sLastMatch.indexOf(RegExp.lastMatch) + 1);
				}
				oFindStruct.mSelect.selectedIndex = oFindStruct.iSelectedIndex;
				if(null != oFindStruct.mFindNext)
				{
					oFindStruct.mFindNext.disabled = false;
					RepaintButton();
				}
				return true;
			}
			oFindStruct.sLastMatch = null;
			oFindStruct.iSelectedIndex++;
		}
		for(var iOption = oFindStruct.iSelectedIndex; iOption < aOptions.length; iOption++)
		{
//			aOptions[iOption].text.match(/^(.+)[\b|\s]+([\B|\S]+.*)[\b|\s]*$/);
			var sDestination = Trim(aOptions[iOption].text);
			if(sDestination.match(oFindStruct.mRegExp))
			{
				if(!g_IsOpera)
				{
					if(g_IsIE)
					{
						oFindStruct.sLastMatch = sDestination.substring(RegExp.index + 1);
					}
					else
					{
						oFindStruct.sLastMatch = sDestination.substring(sDestination.indexOf(RegExp.lastMatch) + 1);
					}
					oFindStruct.iSelectedIndex = iOption;
				}
				else
				{
					oFindStruct.iSelectedIndex = iOption + 1;
				}
				oFindStruct.mSelect.selectedIndex = iOption;
				if(null != oFindStruct.mFindNext)
				{
					oFindStruct.mFindNext.disabled = (null == oFindStruct.sLastMatch);
					RepaintButton();
				}
				return true;
			}
		}
		oFindStruct.iSelectedIndex = 0;
		for(var iOption = oFindStruct.iSelectedIndex; iOption < aOptions.length; iOption++)
		{
			var sDestination = Trim(aOptions[iOption].text);
			if(sDestination.match(oFindStruct.mRegExp))
			{
				if(!g_IsOpera)
				{
					if(g_IsIE)
					{
						oFindStruct.sLastMatch = sDestination.substring(RegExp.index + 1);
					}
					else
					{
						oFindStruct.sLastMatch = sDestination.substring(sDestination.indexOf(RegExp.lastMatch) + 1);
					}
					oFindStruct.iSelectedIndex = iOption;
				}
				else
				{
					oFindStruct.iSelectedIndex = iOption + 1;
				}
				oFindStruct.mSelect.selectedIndex = iOption;
				if(null != oFindStruct.mFindNext)
				{
					oFindStruct.mFindNext.disabled = (null == oFindStruct.sLastMatch);
					RepaintButton();
				}
				return true;
			}
		}
	}
	oFindStruct.sLastMatch = null;
	oFindStruct.iSelectedIndex = 0;
	RepaintButton();
	return false;
}

